function [ P1] = BandSPICEdeconvf1( y,H,q,precision,threshold,rate)
maxy=max(max(y));
y=y.'/maxy;
H=H(:);
[M,N]=size(y);
fH=fftshift(fft(H,M));
[a,b]=find(abs(fH)/max(abs(fH))>=threshold);
buling=round(M);
fy=fftshift(fft(y,buling),1);
fH=fftshift(fft(H,buling));
[a,b]=find(abs(fH)/max(abs(fH))>=threshold);
length(a)
fH1=fH(a(1):a(end))*ones(1,N);
fy1=fy(a(1):a(end),:);
ff=(fy1./fH1);
[P]=sqrt((SPICEspectral(flipud(ff),buling,q,precision,rate)));
P1=P(1:M,:);
P1=circshift(P1,[round(length(H)/2) 0]).';
P1=P1*maxy;
end
function [s]=SPICEspectral(y,K,q,precision,rate)
[M,N]=size(y);
if M==1||N==1
    y=y(:);
end
[M,N]=size(y);
s=zeros(K,N);

f=linspace(0,K-1,K)*2*pi/K;
t=linspace(0,M-1,M)';
A=exp(1j*t*f);
for n=1:N
    s(:,n)=SPICEband(y(:,n),A,q,precision,rate);
end
end
function [s, s1] = SPICEband(y,B,q,precision,rate)
%   UESTC, Yongchao Zhang, 2016.10.26 at Lund Universiy
[M,N]=size(y);
K=size(B,2);
K1=K/rate;
t=linspace(0,M-1,M).';
w=2*pi/K1*linspace(0,K1,K1+1);
B1=1./(1j*2*pi*t)*ones(1,K1).*(exp(1j*t*w(2:K1+1))-exp(1j*t*w(1:K1)));
B1(1,:)=1/K1;
% [M,N]=size(y);
% [M,K]=size(B);

% K1=K/rate;
% B1=zeros(M,K1);
% for k=1:K1
%     B1(:,k)=sum(B(:,1+(k-1)*rate:rate+(k-1)*rate),2);
% end
s=zeros(K,N);
% s1=zeros(K1,N);
for n=1:N
    [s1,threshold]=SPICE(y(:,n),B1,q,precision);
%     [aa,ll]=findpeaks(s1.');
% figure
% plot(abs(s1))
    [ll]=find(s1>=0.1*max(s1));
    if isempty(ll)
    else
        B2=[];
        for l=1:length(ll)
            B2=[B2,B(:,1+(ll(l)-1)*rate:ll(l)*rate)];
        end
        s2=SPICE(y(:,n),B2,q,precision);
        for l=1:length(ll)
            s(1+(ll(l)-1)*rate:ll(l)*rate)=s2(1+(l-1)*rate:l*rate);
        end
    end
end
end

function [p,sigma]=SPICE(y,B,q,precision)
[M,N]=size(y); 
if M==1||N==1
    y=y(:);
end
[M,N]=size(y);
[M1,K]=size(B);
if M~=M1
else
    
    % Initializing
    N = length(y); % Number of samples
    M = size(B,2); % Number of candidates in the dictionary
    I = eye(N);
    A = [B I]; % Makeing the SPICE dictionary
    
    % Initial estimates of p and sigma
    p = abs(B'*y).^2./(normV(B,2,1).^4).';
    sigma = abs(y);%abs(I'*y);
    
    
    % Calculating the different weights
    W_M = normV(I,2,1).^2/norm(y,2)^2;
    W_M = W_M(:);
    W_P = normV(B,2,1).^2/norm(y,2)^2;
    W_P = W_P(:);
    
    pOld = inf*p;
    sigmaOld = inf*sigma;
    
    counter=0;
    
    while norm([p;sigma]-[pOld;sigmaOld])>precision
        norm([p;sigma]-[pOld;sigmaOld]);
        pvec = p;
        % Which element in p are non-zero?
%         ind = find(pvec/max(abs(pvec))>=1e-6);
        ind = find(pvec>=0);
        % Which elements in [p sigma] are non-zero?
        ind2 = [ind; (M+1:M+N)'];
        % Removing the elements and columns corresponding to zero elements in
        % p.
        pvec2 = [p;sigma];
        P = diag(pvec2(ind2));
        Aind = A(:,ind2);
        % Estimating the covariance matrix
%         R = Aind*P*Aind'+0.0*eye(N);
        R = Aind*P*Aind';
        % Precalculating the inverse of R times the signal.
        invRy = R\y;
        % Preallocating beta
        beta = zeros(M+N,1);
        % beta for the non-zero valued elements in p
        beta(ind2) = pvec2(ind2).*(A(:,ind2)'*invRy);
        % save old values
        pOld = p;
        sigmaOld = sigma;
        % precompute the denominator
        den = normsFast(sqrt(W_P).*beta(1:M),1)+normsFast(sqrt(W_M).*beta(M+1:end),2*q/(q+1));
        p = abs(beta(1:M))/den./sqrt(W_P);
        sigma = abs(beta(M+1:end)).^(2/(q+1))/den./W_M.^(q/(q+1))*norm(sqrt(W_M).*beta(M+1:end),2*q/(q+1))^((q-1)/(q+1));
%         sigma=mean(sigma)*ones(N,1);

%         den = normsFast(sqrt(W_P).*beta(1:M),1)+normsFast(N^(1/(2*q)).*beta(M+1:end),2);        
%         p = abs(beta(1:M))/den./sqrt(W_P);
%         sigma=norm(beta(M))/(N^(1/(2*q))*den)*ones(N,1);
        % completed another iteration
        counter = counter + 1;
    end
end
end

function out = normV( x, p, DIM )
out = sum( abs( x ) .^ p, DIM ) .^ ( 1 / p );
end


function out = normsFast( x, p, ~ )

%NORMS   Computation of multiple vector norms.
%   NORMS( X ) provides a means to compute the norms of multiple vectors
%   packed into a matrix or N-D array. This is useful for performing
%   max-of-norms or sum-of-norms calculations.
%
%   All of the vector norms, including the false "-inf" norm, supported
%   by NORM() have been implemented in the NORMS() command.
%     NORMS(X,P)           = sum(abs(X).^P).^(1/P)
%     NORMS(X)             = NORMS(X,2).
%     NORMS(X,inf)         = max(abs(X)).
%     NORMS(X,-inf)        = min(abs(X)).
%   If X is a vector, these computations are completely identical to
%   their NORM equivalents. If X is a matrix, a row vector is returned
%   of the norms of each column of X. If X is an N-D matrix, the norms
%   are computed along the first non-singleton dimension.
%
%   NORMS( X, [], DIM ) or NORMS( X, 2, DIM ) computes Euclidean norms
%   along the dimension DIM. NORMS( X, P, DIM ) computes its norms
%   along the dimension DIM.
%
%   Disciplined convex programming information:
%       NORMS is convex, except when P<1, so an error will result if these
%       non-convex "norms" are used within CVX expressions. NORMS is
%       nonmonotonic, so its input must be affine.

% 
% Check second argument
% Johan Swrd,  modifications to lower computational complexity

out = sum( abs( x ) .^ p, 1 ) .^ ( 1 / p );
end