function [ P1] = SPICEdeconvf( y,H,q,precision, threshold)
%   UESTC,zyc,2016.5.8
maxy=max(max(y));
y=y.'/maxy;
H=H(:);
[M,N]=size(y);
fH=fftshift(fft(H,M));
[a,b]=find(abs(fH)/max(abs(fH))>=threshold);
buling=round(M);
fy=fftshift(fft(y,buling),1);
fH=fftshift(fft(H,buling));
[a,b]=find(abs(fH)/max(abs(fH))>=threshold);
length(a)
fH1=fH(a(1):a(end))*ones(1,N);
fy1=fy(a(1):a(end),:);
ff=(fy1./fH1);
[P]=sqrt((SPICEspectral(flipud(ff),buling,q,precision)));
P1=P(1:M,:);
P1=circshift(P1,[round(length(H)/2) 0]).';
P1=P1*maxy;
end
function [s]=SPICEspectral(y,K,q,precision)
[M,N]=size(y);
if M==1||N==1
    y=y(:);
end
[M,N]=size(y);
s=zeros(K,N);

f=linspace(0,K-1,K)*2*pi/K;
t=linspace(0,M-1,M)';
A=exp(1j*t*f);
for n=1:N
    s(:,n)=SPICE(y(:,n),A,q,precision);
end
end

function [p,sigma]=SPICE(y,B,q,precision)
[M,N]=size(y);
y=y(:);
K=size(B,2);

% Initializing
I = eye(M);
A = [B I]; % Makeing the SPICE dictionary

% Initial estimates of p and sigma
p = abs(B'*y).^2./(normV(B,2,1).^4).';
sigma = abs(y);%abs(I'*y);

% Calculating the different weights
W_M = normV(I,2,1).^2/norm(y,2)^2;
W_M = W_M(:);
W_P = normV(B,2,1).^2/norm(y,2)^2;
W_P = W_P(:);

pOld = inf*p;
sigmaOld = inf*sigma;
counter=0;
while norm([p;sigma]-[pOld;sigmaOld])>precision
    pvec = p;
    % Which element in p are non-zero?
    %         ind = find(pvec/max(abs(pvec))>=1e-6);
    ind = find(pvec>=0);
    % Which elements in [p sigma] are non-zero?
    ind2 = [ind; (K+1:K+M)'];
    % Removing the elements and columns corresponding to zero elements in
    % p.
    pvec2 = [p;sigma];
    P = diag(pvec2(ind2));
    Aind = A(:,ind2);
    % Estimating the covariance matrix
    %         R = Aind*P*Aind'+0.0*eye(N);
    R = Aind*P*Aind';
    % Precalculating the inverse of R times the signal.
    invRy = R\y;
    % Preallocating beta
    beta = zeros(K+M,1);
    % beta for the non-zero valued elements in p
    beta(ind2) = pvec2(ind2).*(A(:,ind2)'*invRy);
    % save old values
    pOld = p;
    sigmaOld = sigma;
    % precompute the denominator
    den = normsFast(sqrt(W_P).*beta(1:K),1)+normsFast(sqrt(W_M).*beta(K+1:end),2*q/(q+1));
    p = abs(beta(1:K))/den./sqrt(W_P);
    sigma = abs(beta(K+1:end)).^(2/(q+1))/den./W_M.^(q/(q+1))*norm(sqrt(W_M).*beta(K+1:end),2*q/(q+1))^((q-1)/(q+1));
    %         sigma=mean(sigma)*ones(N,1);
    
%             den = normsFast(sqrt(W_P).*beta(1:K),1)+normsFast(M^(1/(2*q)).*beta(K+1:end),2);
%             p = abs(beta(1:K))/den./sqrt(W_P);
%             sigma=norm(beta(K))/(M^(1/(2*q))*den)*ones(M,1);
    % completed another iteration
    counter = counter + 1;
        % Total amount of iteration until convergence

end
% figure
%         plot(p)
%     [aa,ll]=findpeaks(p.');
%     ll
%     pls1=(B(:,ll)'*B(:,ll))\B(:,ll)'*y;
%     pls=zeros(size(p));
%     pls(ll)=pls1;
%     hold on
%     plot(pls)
end

function out = normV( x, p, DIM )
out = sum( abs( x ) .^ p, DIM ) .^ ( 1 / p );
end

function out = normsFast( x, p, ~ )
out = sum( abs( x ) .^ p, 1 ) .^ ( 1 / p );
end