function s = deconvIAAf ( y, h, precision, threshold)
%   UESTC, Yongchao Zhang
y=y.';
h=h(:);
[M,N]=size(y);
L=length(h);
buling=round(M);
fy=fftshift(fft(y,buling),1);
fH=fftshift(fft(h,buling));
[a,b]=find(abs(fH)/max(abs(fH))>=threshold);
length(a)
fH1=fH(a(1):a(end))*ones(1,N);
fy1=fy(a(1):a(end),:);
ff=(fy1./fH1);
s=zeros(M,N);
for n=1:N
    n
    s(:,n)=((IAAspectral(flipud(ff(:,n)),buling,precision)));
end
% s=IAAspectral(flipud(ff),buling,precision);
s=s(1:M,:);
s=circshift(s,[round(L/2) 0]).';
end

function s =IAAspectral( y, K, precision)
[M,N]=size(y);
if M==1||N==1
    y=y(:);
end
f=linspace(0,K-1,K)*2*pi/K;
t=linspace(0,M-1,M)';
A=exp(1j*t*f);
s=IAA(y,A,precision);
end

function s =IAA( y, A, precision)

[M,K]=size(A);
s=zeros(K,1);
P=zeros(K,1);
for k=1:K
    s(k)=A(:,k)'*y/(A(:,k)'*A(:,k));
    P(k,1)=(abs(s(k)))^2;
end
pold=inf*P;
while(norm(pold-P)>precision)
    R=A*diag(P)*A';    
    pold=P;
    RR=inv(R);
    for k=1:K
        s(k)=A(:,k)'*RR*y/(A(:,k)'*RR*A(:,k));
        P(k,1)=(abs(s(k)))^2;
    end
end
end