function [ P1] = deconvSLIMf( y,H,threshold,threshold1)
y=y.';
Hf=fftshift(abs(fft(H)));
[M,N]=size(y);
H=H(:);
fH=fftshift(fft(H,M));
buling=round(M);
fy=fftshift(fft(y,buling),1);
fH=fftshift(fft(H,buling));
[a,b]=find(abs(fH)/max(abs(fH))>=threshold);
length(a)
fH1=fH(a(1):a(end))*ones(1,N);
fy1=fy(a(1):a(end),:);
ff=(fy1./fH1);
[P]=((SLIMspectral(flipud(ff),buling,threshold1)));
P1=P(1:M,:);
P1=circshift(P1,[round(length(H)/2) 0]).';
end

function [s]=SLIMspectral(y,K,threshold)
[M,N]=size(y);
if M==1||N==1
    y=y(:);
end
[M,N]=size(y);
s=zeros(K,N);

f=linspace(0,K-1,K)*2*pi/K;
t=linspace(0,M-1,M)';
A=exp(1j*t*f);
for n=1:N
    s(:,n)=SLIM(y(:,n),A,threshold);
end
end

function [s1]=SLIM(y,B,threshold)

[M,N]=size(y); 
y=y(:);
K=size(B,2);

% Initializing
I = eye(M);
A = [B I]; % Makeing the SPICE dictionary

% Initial estimates of p and sigma
p = abs(B'*y).^2./(normV(B,2,1).^4).';
sigma = 10*mean(abs(y).^2);

pOld = inf*p;

counter=0;
while norm(p-pOld)>threshold
    R = B*diag(p)*B'+sigma*eye(M);
    % Precalculating the inverse of R times the signal.
    invRy = R\y;
    % Preallocating beta 
    % beta for the non-zeroy valued elements in p
    s= p.*(B'*invRy);
    pOld = p;
    p=abs(s).^2;    
    sigma=norm(y-B*s,2)^2/M;
    % save old values
    counter = counter + 1;
end
% counter
s1=s(1:K);
end

function out = normV( x, p, DIM )
out = sum( abs( x ) .^ p, DIM ) .^ ( 1 / p );
end